diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/dquot.c linux-2.4.25-rc2-vs1.26-q0.13/fs/dquot.c
--- linux-2.4.25-rc2-vs1.26/fs/dquot.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/dquot.c	2004-02-13 00:53:54.000000000 +0100
@@ -1461,9 +1702,9 @@ int vfs_get_dqinfo(struct super_block *s
 }
 
 /* Generic routine for setting common part of quota file information */
-int vfs_set_dqinfo(struct super_block *sb, int type, struct if_dqinfo *ii)
+int vfs_set_dqinfo(struct dqhash *hash, int type, struct if_dqinfo *ii)
 {
-	struct mem_dqinfo *mi = sb_dqopt(sb)->info + type;
+	struct mem_dqinfo *mi = dqh_dqopt(hash)->info + type;
 
 	if (ii->dqi_valid & IIF_BGRACE)
 		mi->dqi_bgrace = ii->dqi_bgrace;
@@ -1507,13 +1748,19 @@ static ctl_table sys_table[] = {
 	{},
 };
 
-static int __init dquot_init(void)
+int	__init init_dqhash_hash(void)
 {
 	int i;
 
+	dprintk("··· dqhash init?\n");
+	for (i = 0; i < NR_DQH_HASH; i++)
+		INIT_LIST_HEAD(dqhash_hash + i);
+	return 0;
+}
+
+static int __init dquot_init(void)
+{
 	register_sysctl_table(sys_table, 0);
-	for (i = 0; i < NR_DQHASH; i++)
-		INIT_LIST_HEAD(dquot_hash + i);
 	printk(KERN_NOTICE "VFS: Disk quotas v%s\n", __DQUOT_VERSION__);
 
 	return 0;
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext2/balloc.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/balloc.c
--- linux-2.4.25-rc2-vs1.26/fs/ext2/balloc.c	2003-06-13 16:51:37.000000000 +0200
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/balloc.c	2004-02-13 00:53:54.000000000 +0100
@@ -359,7 +359,7 @@ int ext2_new_block (struct inode * inode
 	struct buffer_head * bh2;
 	char * p, * r;
 	int i, j, k, tmp;
-	int bitmap_nr;
+	int bitmap_nr, sys_res;
 	struct super_block * sb;
 	struct ext2_group_desc * gdp;
 	struct ext2_super_block * es;
@@ -374,12 +374,14 @@ int ext2_new_block (struct inode * inode
 	}
 
 	lock_super (sb);
+	sys_res = (sb->u.ext2_sb.s_resuid == current->fsuid) ||
+		(sb->u.ext2_sb.s_resgid != 0 &&
+	          in_group_p (sb->u.ext2_sb.s_resgid)) ||
+	        capable(CAP_SYS_RESOURCE);
+
 	es = sb->u.ext2_sb.s_es;
 	if (le32_to_cpu(es->s_free_blocks_count) <= le32_to_cpu(es->s_r_blocks_count) &&
-	    ((sb->u.ext2_sb.s_resuid != current->fsuid) &&
-	     (sb->u.ext2_sb.s_resgid == 0 ||
-	      !in_group_p (sb->u.ext2_sb.s_resgid)) && 
-	     !capable(CAP_SYS_RESOURCE)))
+		!sys_res)
 		goto out;
 
 	ext2_debug ("goal=%lu.\n", goal);
@@ -508,7 +510,11 @@ got_block:
 	/*
 	 * Check quota for allocation of this block.
 	 */
-	if(DQUOT_ALLOC_BLOCK(inode, 1)) {
+	if (!dlimit_block_avail(inode->i_sb, sys_res, 1)) {
+		*err = -ENOSPC;
+		goto out;
+	}
+	if (DQUOT_ALLOC_BLOCK(inode, 1)) {
 		*err = -EDQUOT;
 		goto out;
 	}
@@ -553,6 +559,8 @@ got_block:
 		for (k = 1;
 		     k < prealloc_goal && (j + k) < EXT2_BLOCKS_PER_GROUP(sb);
 		     k++, next_block++) {
+			if (!dlimit_block_avail(inode->i_sb, sys_res, 1))
+				break;
 			if (DQUOT_PREALLOC_BLOCK(inode, 1))
 				break;
 			/* Writer: ->i_prealloc* */
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext2/ialloc.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/ialloc.c
--- linux-2.4.25-rc2-vs1.26/fs/ext2/ialloc.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/ialloc.c	2004-02-13 00:53:54.000000000 +0100
@@ -327,6 +327,8 @@ struct inode * ext2_new_inode (const str
 	inode = new_inode(sb);
 	if (!inode)
 		return ERR_PTR(-ENOMEM);
+	if (!dlimit_inodes_avail(sb, 1))
+		return ERR_PTR(-ENOSPC);
 
 	lock_super (sb);
 	es = sb->u.ext2_sb.s_es;
@@ -396,7 +398,7 @@ repeat:
 	mark_inode_dirty(inode);
 
 	unlock_super (sb);
-	if(DQUOT_ALLOC_INODE(inode)) {
+	if (DQUOT_ALLOC_INODE(inode)) {
 		DQUOT_DROP(inode);
 		inode->i_flags |= S_NOQUOTA;
 		inode->i_nlink = 0;
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext2/inode.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/inode.c
--- linux-2.4.25-rc2-vs1.26/fs/ext2/inode.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/inode.c	2004-02-13 00:53:54.000000000 +0100
@@ -924,6 +924,8 @@ void ext2_read_inode (struct inode * ino
 	unsigned long block;
 	unsigned long offset;
 	struct ext2_group_desc * gdp;
+	uid_t uid;
+	gid_t gid;
 
 	if ((inode->i_ino != EXT2_ROOT_INO && inode->i_ino != EXT2_ACL_IDX_INO &&
 	     inode->i_ino != EXT2_ACL_DATA_INO &&
@@ -966,12 +968,19 @@ void ext2_read_inode (struct inode * ino
 	raw_inode = (struct ext2_inode *) (bh->b_data + offset);
 
 	inode->i_mode = le16_to_cpu(raw_inode->i_mode);
-	inode->i_uid = (uid_t)le16_to_cpu(raw_inode->i_uid_low);
-	inode->i_gid = (gid_t)le16_to_cpu(raw_inode->i_gid_low);
+	uid = (uid_t)le16_to_cpu(raw_inode->i_uid_low);
+	gid = (gid_t)le16_to_cpu(raw_inode->i_gid_low);
 	if(!(test_opt (inode->i_sb, NO_UID32))) {
-		inode->i_uid |= le16_to_cpu(raw_inode->i_uid_high) << 16;
-		inode->i_gid |= le16_to_cpu(raw_inode->i_gid_high) << 16;
+		uid |= le16_to_cpu(raw_inode->i_uid_high) << 16;
+		gid |= le16_to_cpu(raw_inode->i_gid_high) << 16;
 	}
+	inode->i_uid = INOXID_UID(uid, gid);
+	inode->i_gid = INOXID_GID(uid, gid);
+	if (inode->i_sb->s_flags & MS_TAGXID) {
+		int xid = INOXID_XID(uid, gid, le16_to_cpu(raw_inode->i_raw_xid));
+		__vx_dq_modify(inode, xid);
+	}	
+
 	inode->i_nlink = le16_to_cpu(raw_inode->i_links_count);
 	inode->i_size = le32_to_cpu(raw_inode->i_size);
 	inode->i_atime = le32_to_cpu(raw_inode->i_atime);
@@ -1054,6 +1063,8 @@ static int ext2_update_inode(struct inod
 	unsigned long offset;
 	int err = 0;
 	struct ext2_group_desc * gdp;
+	uid_t uid;
+	gid_t gid;
 
 	if ((inode->i_ino != EXT2_ROOT_INO &&
 	     inode->i_ino < EXT2_FIRST_INO(inode->i_sb)) ||
@@ -1098,27 +1109,33 @@ static int ext2_update_inode(struct inod
 	if (inode->u.ext2_i.i_state & EXT2_STATE_NEW)
 		memset(raw_inode, 0, EXT2_SB(inode->i_sb)->s_inode_size);
 
+	uid = XIDINO_UID(inode->i_uid, inode->i_xid);
+	gid = XIDINO_GID(inode->i_gid, inode->i_xid);
+
 	raw_inode->i_mode = cpu_to_le16(inode->i_mode);
 	if(!(test_opt(inode->i_sb, NO_UID32))) {
-		raw_inode->i_uid_low = cpu_to_le16(low_16_bits(inode->i_uid));
-		raw_inode->i_gid_low = cpu_to_le16(low_16_bits(inode->i_gid));
+		raw_inode->i_uid_low = cpu_to_le16(low_16_bits(uid));
+		raw_inode->i_gid_low = cpu_to_le16(low_16_bits(gid));
 /*
  * Fix up interoperability with old kernels. Otherwise, old inodes get
  * re-used with the upper 16 bits of the uid/gid intact
  */
 		if(!inode->u.ext2_i.i_dtime) {
-			raw_inode->i_uid_high = cpu_to_le16(high_16_bits(inode->i_uid));
-			raw_inode->i_gid_high = cpu_to_le16(high_16_bits(inode->i_gid));
+			raw_inode->i_uid_high = cpu_to_le16(high_16_bits(uid));
+			raw_inode->i_gid_high = cpu_to_le16(high_16_bits(gid));
 		} else {
 			raw_inode->i_uid_high = 0;
 			raw_inode->i_gid_high = 0;
 		}
 	} else {
-		raw_inode->i_uid_low = cpu_to_le16(fs_high2lowuid(inode->i_uid));
-		raw_inode->i_gid_low = cpu_to_le16(fs_high2lowgid(inode->i_gid));
+		raw_inode->i_uid_low = cpu_to_le16(fs_high2lowuid(uid));
+		raw_inode->i_gid_low = cpu_to_le16(fs_high2lowgid(gid));
 		raw_inode->i_uid_high = 0;
 		raw_inode->i_gid_high = 0;
 	}
+#ifdef CONFIG_INOXID_GID32	
+	raw_inode->i_raw_xid = cpu_to_le16(inode->i_xid);
+#endif
 	raw_inode->i_links_count = cpu_to_le16(inode->i_nlink);
 	raw_inode->i_size = cpu_to_le32(inode->i_size);
 	raw_inode->i_atime = cpu_to_le32(inode->i_atime);
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext2/super.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/super.c
--- linux-2.4.25-rc2-vs1.26/fs/ext2/super.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext2/super.c	2004-02-13 00:53:54.000000000 +0100
@@ -180,6 +180,10 @@ static int parse_options (char * options
 		else if (!strcmp (this_char, "nouid32")) {
 			set_opt (*mount_options, NO_UID32);
 		}
+		else if (!strcmp (this_char, "tagctx"))
+			set_opt (*mount_options, TAG_XID);
+		else if (!strcmp (this_char, "tagxid"))
+			set_opt (*mount_options, TAG_XID);
 		else if (!strcmp (this_char, "check")) {
 			if (!value || !*value || !strcmp (value, "none"))
 				clear_opt (*mount_options, CHECK);
@@ -450,6 +454,8 @@ struct super_block * ext2_read_super (st
 	    &sb->u.ext2_sb.s_mount_opt)) {
 		return NULL;
 	}
+	if (sb->u.ext2_sb.s_mount_opt & EXT2_MOUNT_TAG_XID)
+		sb->s_flags |= MS_TAGXID;
 
 	if (set_blocksize(dev, blocksize) < 0) {
 		printk ("EXT2-fs: unable to set blocksize %d\n", blocksize);
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext3/balloc.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/balloc.c
--- linux-2.4.25-rc2-vs1.26/fs/ext3/balloc.c	2003-06-13 16:51:37.000000000 +0200
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/balloc.c	2004-02-13 00:53:54.000000000 +0100
@@ -538,7 +538,7 @@ int ext3_new_block (handle_t *handle, st
 	char * p, * r;
 #endif
 	int i, j, k, tmp, alloctmp;
-	int bitmap_nr;
+	int bitmap_nr, sys_res;
 	int fatal = 0, err;
 	int performed_allocation = 0;
 	struct super_block * sb;
@@ -563,13 +563,20 @@ int ext3_new_block (handle_t *handle, st
 	}
 
 	lock_super (sb);
+	sys_res = (sb->u.ext3_sb.s_resuid == current->fsuid) ||
+		(sb->u.ext3_sb.s_resgid != 0 &&
+		 in_group_p (sb->u.ext3_sb.s_resgid)) ||
+		capable(CAP_SYS_RESOURCE);
+
+	if (!dlimit_block_avail(inode->i_sb, sys_res, 1)) {
+		*errp = -ENOSPC;
+		goto out;
+	}
+
 	es = sb->u.ext3_sb.s_es;
 	if (le32_to_cpu(es->s_free_blocks_count) <=
 			le32_to_cpu(es->s_r_blocks_count) &&
-	    ((sb->u.ext3_sb.s_resuid != current->fsuid) &&
-	     (sb->u.ext3_sb.s_resgid == 0 ||
-	      !in_group_p (sb->u.ext3_sb.s_resgid)) && 
-	     !capable(CAP_SYS_RESOURCE)))
+			!sys_res)
 		goto out;
 
 	ext3_debug ("goal=%lu.\n", goal);
@@ -747,6 +754,8 @@ got_block:
 		for (k = 1;
 		     k < prealloc_goal && (j + k) < EXT3_BLOCKS_PER_GROUP(sb);
 		     k++, next_block++) {
+			if (!dlimit_block_avail(inode->i_sb, sys_res, 1))
+				break;
 			if (DQUOT_PREALLOC_BLOCK(inode, 1))
 				break;
 			/* Writer: ->i_prealloc* */
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext3/ialloc.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/ialloc.c
--- linux-2.4.25-rc2-vs1.26/fs/ext3/ialloc.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/ialloc.c	2004-02-13 00:53:54.000000000 +0100
@@ -318,6 +318,8 @@ struct inode * ext3_new_inode (handle_t 
 	inode = new_inode(sb);
 	if (!inode)
 		return ERR_PTR(-ENOMEM);
+	if (!dlimit_inodes_avail(sb, 1))
+			return ERR_PTR(-ENOSPC);
 	init_rwsem(&inode->u.ext3_i.truncate_sem);
 
 	lock_super (sb);
@@ -511,7 +513,7 @@ repeat:
 	if (err) goto fail;
 	
 	unlock_super (sb);
-	if(DQUOT_ALLOC_INODE(inode)) {
+	if (DQUOT_ALLOC_INODE(inode)) {
 		DQUOT_DROP(inode);
 		inode->i_flags |= S_NOQUOTA;
 		inode->i_nlink = 0;
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext3/inode.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/inode.c
--- linux-2.4.25-rc2-vs1.26/fs/ext3/inode.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/inode.c	2004-02-13 00:53:54.000000000 +0100
@@ -2112,6 +2112,8 @@ void ext3_read_inode(struct inode * inod
 	struct ext3_inode *raw_inode;
 	struct buffer_head *bh;
 	int block;
+	uid_t uid;
+	gid_t gid;
 	
 	if(ext3_get_inode_loc(inode, &iloc))
 		goto bad_inode;
@@ -2119,12 +2121,19 @@ void ext3_read_inode(struct inode * inod
 	raw_inode = iloc.raw_inode;
 	init_rwsem(&inode->u.ext3_i.truncate_sem);
 	inode->i_mode = le16_to_cpu(raw_inode->i_mode);
-	inode->i_uid = (uid_t)le16_to_cpu(raw_inode->i_uid_low);
-	inode->i_gid = (gid_t)le16_to_cpu(raw_inode->i_gid_low);
+	uid = (uid_t)le16_to_cpu(raw_inode->i_uid_low);
+	gid = (gid_t)le16_to_cpu(raw_inode->i_gid_low);
 	if(!(test_opt (inode->i_sb, NO_UID32))) {
-		inode->i_uid |= le16_to_cpu(raw_inode->i_uid_high) << 16;
-		inode->i_gid |= le16_to_cpu(raw_inode->i_gid_high) << 16;
+		uid |= le16_to_cpu(raw_inode->i_uid_high) << 16;
+		gid |= le16_to_cpu(raw_inode->i_gid_high) << 16;
 	}
+	inode->i_uid = INOXID_UID(uid, gid);
+	inode->i_gid = INOXID_GID(uid, gid);
+	if (inode->i_sb->s_flags & MS_TAGXID) {
+		int xid = INOXID_XID(uid, gid, le16_to_cpu(raw_inode->i_raw_xid));
+		__vx_dq_modify(inode, xid);
+	}
+	
 	inode->i_nlink = le16_to_cpu(raw_inode->i_links_count);
 	inode->i_size = le32_to_cpu(raw_inode->i_size);
 	inode->i_atime = le32_to_cpu(raw_inode->i_atime);
@@ -2223,6 +2232,8 @@ static int ext3_do_update_inode(handle_t
 	struct ext3_inode *raw_inode = iloc->raw_inode;
 	struct buffer_head *bh = iloc->bh;
 	int err = 0, rc, block;
+	uid_t uid;
+	gid_t gid;
 
 	if (handle) {
 		BUFFER_TRACE(bh, "get_write_access");
@@ -2235,31 +2246,37 @@ static int ext3_do_update_inode(handle_t
 	if (EXT3_I(inode)->i_state & EXT3_STATE_NEW)
 		memset(raw_inode, 0, EXT3_SB(inode->i_sb)->s_inode_size);
 
+	uid = XIDINO_UID(inode->i_uid, inode->i_xid);
+	gid = XIDINO_GID(inode->i_gid, inode->i_xid);
+	
 	raw_inode->i_mode = cpu_to_le16(inode->i_mode);
 	if(!(test_opt(inode->i_sb, NO_UID32))) {
-		raw_inode->i_uid_low = cpu_to_le16(low_16_bits(inode->i_uid));
-		raw_inode->i_gid_low = cpu_to_le16(low_16_bits(inode->i_gid));
+		raw_inode->i_uid_low = cpu_to_le16(low_16_bits(uid));
+		raw_inode->i_gid_low = cpu_to_le16(low_16_bits(gid));
 /*
  * Fix up interoperability with old kernels. Otherwise, old inodes get
  * re-used with the upper 16 bits of the uid/gid intact
  */
 		if(!inode->u.ext3_i.i_dtime) {
 			raw_inode->i_uid_high =
-				cpu_to_le16(high_16_bits(inode->i_uid));
+				cpu_to_le16(high_16_bits(uid));
 			raw_inode->i_gid_high =
-				cpu_to_le16(high_16_bits(inode->i_gid));
+				cpu_to_le16(high_16_bits(gid));
 		} else {
 			raw_inode->i_uid_high = 0;
 			raw_inode->i_gid_high = 0;
 		}
 	} else {
 		raw_inode->i_uid_low =
-			cpu_to_le16(fs_high2lowuid(inode->i_uid));
+			cpu_to_le16(fs_high2lowuid(uid));
 		raw_inode->i_gid_low =
-			cpu_to_le16(fs_high2lowgid(inode->i_gid));
+			cpu_to_le16(fs_high2lowgid(gid));
 		raw_inode->i_uid_high = 0;
 		raw_inode->i_gid_high = 0;
 	}
+#ifdef CONFIG_INOXID_GID32
+        raw_inode->i_raw_xid = cpu_to_le16(inode->i_xid);
+#endif
 	raw_inode->i_links_count = cpu_to_le16(inode->i_nlink);
 	raw_inode->i_size = cpu_to_le32(inode->u.ext3_i.i_disksize);
 	raw_inode->i_atime = cpu_to_le32(inode->i_atime);
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext3/ioctl.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/ioctl.c
--- linux-2.4.25-rc2-vs1.26/fs/ext3/ioctl.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/ioctl.c	2004-02-13 00:53:54.000000000 +0100
@@ -149,6 +149,38 @@ flags_err:
 			return ret;
 		}
 #endif
+#ifndef CONFIG_INOXID_NONE
+	case EXT3_IOC_SETXID: {
+		handle_t *handle;
+		struct ext3_iloc iloc;
+		int xid;
+		int err;
+
+		/* fixme: if stealth, return -ENOTTY */
+		if (!capable(CAP_CONTEXT))
+			return -EPERM;
+		if (IS_RDONLY(inode))
+			return -EROFS;
+		if (!(inode->i_sb->s_flags & MS_TAGXID))
+			return -ENOSYS;
+		if (get_user(xid, (int *) arg))
+			return -EFAULT;	
+
+		handle = ext3_journal_start(inode, 1);
+		if (IS_ERR(handle))
+			return PTR_ERR(handle);
+		err = ext3_reserve_inode_write(handle, inode, &iloc);
+		if (err)
+			return err;
+
+		inode->i_xid = (xid & 0xFFFF);
+		inode->i_ctime = CURRENT_TIME;
+
+		err = ext3_mark_iloc_dirty(handle, inode, &iloc);
+		ext3_journal_stop(handle, inode);
+		return err;
+	}
+#endif
 	default:
 		return -ENOTTY;
 	}
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ext3/super.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/super.c
--- linux-2.4.25-rc2-vs1.26/fs/ext3/super.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ext3/super.c	2004-02-13 00:53:54.000000000 +0100
@@ -521,6 +521,10 @@ static int parse_options (char * options
 		else if (!strcmp (this_char, "nouid32")) {
 			set_opt (*mount_options, NO_UID32);
 		}
+		else if (!strcmp (this_char, "tagctx"))
+			set_opt (*mount_options, TAG_XID);
+		else if (!strcmp (this_char, "tagxid"))
+			set_opt (*mount_options, TAG_XID);
 		else if (!strcmp (this_char, "abort"))
 			set_opt (*mount_options, ABORT);
 		else if (!strcmp (this_char, "check")) {
@@ -955,6 +959,8 @@ struct super_block * ext3_read_super (st
 		sb->s_dev = 0;
 		goto out_fail;
 	}
+	if (sbi->s_mount_opt & EXT3_MOUNT_TAG_XID)
+		sb->s_flags |= MS_TAGXID;
 
 	sb->s_blocksize = blocksize;
 	set_blocksize (dev, blocksize);
@@ -1154,7 +1160,7 @@ struct super_block * ext3_read_super (st
 	 * set up enough so that it can read an inode
 	 */
 	sb->s_op = &ext3_sops;
-	sb->dq_op = &ext3_qops;
+	sb->s_qop = &ext3_qops;
 	INIT_LIST_HEAD(&sbi->s_orphan); /* unlinked but open files */
 
 	sb->s_root = 0;
@@ -1808,7 +1814,7 @@ static int ext3_write_dquot(struct dquot
 {
 	int nblocks, ret;
 	handle_t *handle;
-	struct quota_info *dqops = sb_dqopt(dquot->dq_sb);
+	struct quota_info *dqops = dqh_dqopt(dquot->dq_dqh);
 	struct inode *qinode;
 
 	switch (dqops->info[dquot->dq_type].dqi_format->qf_fmt_id) {
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/inode.c linux-2.4.25-rc2-vs1.26-q0.13/fs/inode.c
--- linux-2.4.25-rc2-vs1.26/fs/inode.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/inode.c	2004-02-13 00:53:54.000000000 +0100
@@ -97,6 +97,11 @@ static struct inode *alloc_inode(struct 
 		struct address_space * const mapping = &inode->i_data;
 
 		inode->i_sb = sb;
+		if (sb->s_flags & MS_TAGXID)
+			inode->i_xid = current->vx_id;
+		else
+			inode->i_xid = 0;       /* maybe xid -1 would be better? */
+		inode->i_dqh = get_dqhash(sb, inode->i_xid);
 		inode->i_dev = sb->s_dev;
 		inode->i_blkbits = sb->s_blocksize_bits;
 		inode->i_flags = 0;
@@ -125,6 +130,8 @@ static struct inode *alloc_inode(struct 
 
 static void destroy_inode(struct inode *inode) 
 {
+	if (dqhash_valid(inode->i_dqh))
+		dqhput(inode->i_dqh);
 	if (inode_has_buffers(inode))
 		BUG();
 	/* Reinitialise the waitqueue head because __wait_on_freeing_inode()
@@ -1397,13 +1404,14 @@ void update_mctime (struct inode *inode)
 void put_dquot_list(struct list_head *);
 int remove_inode_dquot_ref(struct inode *, short, struct list_head *);
 
-void remove_dquot_ref(struct super_block *sb, short type)
+void remove_dquot_ref(struct dqhash *hash, short type)
 {
 	struct inode *inode;
 	struct list_head *act_head;
+	struct super_block *sb = hash->dqh_sb;
 	LIST_HEAD(tofree_head);
 
-	if (!sb->dq_op)
+	if (!hash->dqh_qop)
 		return;	/* nothing to do */
 	/* We have to be protected against other CPUs */
 	lock_kernel();		/* This lock is for quota code */
@@ -1411,33 +1419,75 @@ void remove_dquot_ref(struct super_block
  
 	list_for_each(act_head, &inode_in_use) {
 		inode = list_entry(act_head, struct inode, i_list);
-		if (inode->i_sb == sb && IS_QUOTAINIT(inode))
+		if (inode->i_dqh == hash && IS_QUOTAINIT(inode))
 			remove_inode_dquot_ref(inode, type, &tofree_head);
 	}
 	list_for_each(act_head, &inode_unused) {
 		inode = list_entry(act_head, struct inode, i_list);
-		if (inode->i_sb == sb && IS_QUOTAINIT(inode))
+		if (inode->i_dqh == hash && IS_QUOTAINIT(inode))
 			remove_inode_dquot_ref(inode, type, &tofree_head);
 	}
 	list_for_each(act_head, &inode_unused_pagecache) {
 		inode = list_entry(act_head, struct inode, i_list);
-		if (inode->i_sb == sb && IS_QUOTAINIT(inode))
+		if (inode->i_dqh == hash && IS_QUOTAINIT(inode))
 			remove_inode_dquot_ref(inode, type, &tofree_head);
 	}
 	list_for_each(act_head, &sb->s_dirty) {
 		inode = list_entry(act_head, struct inode, i_list);
-		if (IS_QUOTAINIT(inode))
+		if (inode->i_dqh == hash && IS_QUOTAINIT(inode))
 			remove_inode_dquot_ref(inode, type, &tofree_head);
 	}
 	list_for_each(act_head, &sb->s_locked_inodes) {
 		inode = list_entry(act_head, struct inode, i_list);
-		if (IS_QUOTAINIT(inode))
+		if (inode->i_dqh == hash && IS_QUOTAINIT(inode))
 			remove_inode_dquot_ref(inode, type, &tofree_head);
 	}
 	spin_unlock(&inode_lock);
 	unlock_kernel();
 
 	put_dquot_list(&tofree_head);
+	dqhput(hash); /* is this required? */
+}
+
+int remove_inode_dqhash_ref(struct inode *);
+
+void remove_dqhash_ref(struct dqhash *hash)
+{
+	struct list_head *act_head;
+	struct super_block *sb = hash->dqh_sb;
+	struct inode *inode;
+
+	lock_kernel();          /* This lock is for quota code */
+	spin_lock(&inode_lock); /* This lock is for inodes code */
+
+	list_for_each(act_head, &inode_in_use) {
+		inode = list_entry(act_head, struct inode, i_list);
+		if (inode->i_dqh == hash)
+			remove_inode_dqhash_ref(inode);
+	}
+	list_for_each(act_head, &inode_unused) {
+		inode = list_entry(act_head, struct inode, i_list);
+		if (inode->i_dqh == hash)
+			remove_inode_dqhash_ref(inode);
+	}
+	list_for_each(act_head, &inode_unused_pagecache) {
+		inode = list_entry(act_head, struct inode, i_list);
+		if (inode->i_dqh == hash)
+			remove_inode_dqhash_ref(inode);
+	}
+	list_for_each(act_head, &sb->s_dirty) {
+		inode = list_entry(act_head, struct inode, i_list);
+		if (inode->i_dqh == hash)
+			remove_inode_dqhash_ref(inode);
+	}
+	list_for_each(act_head, &sb->s_locked_inodes) {
+		inode = list_entry(act_head, struct inode, i_list);
+		if (inode->i_dqh == hash)
+			remove_inode_dqhash_ref(inode);
+	}
+	spin_unlock(&inode_lock);
+	unlock_kernel();
 }
 
+
 #endif
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/ioctl.c linux-2.4.25-rc2-vs1.26-q0.13/fs/ioctl.c
--- linux-2.4.25-rc2-vs1.26/fs/ioctl.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/ioctl.c	2004-02-13 00:53:54.000000000 +0100
@@ -115,6 +115,40 @@ asmlinkage long sys_ioctl(unsigned int f
 			else
 				error = -ENOTTY;
 			break;
+#ifndef CONFIG_INOXID_NONE
+		case FIOC_GETXID: {
+			struct inode *inode = filp->f_dentry->d_inode;
+
+			/* fixme: if stealth, return -ENOTTY */
+			error = -EPERM;
+			if (capable(CAP_CONTEXT))
+				error = put_user(inode->i_xid, (int *) arg);
+			break;
+		}
+		case FIOC_SETXID: {
+			struct inode *inode = filp->f_dentry->d_inode;
+			int xid;
+
+			/* fixme: if stealth, return -ENOTTY */
+			error = -EPERM;
+			if (!capable(CAP_CONTEXT))
+				break;
+			error = -EROFS;
+			if (IS_RDONLY(inode))
+				break;
+			error = -ENOSYS;
+			if (!(inode->i_sb->s_flags & MS_TAGXID))
+				break;
+			error = -EFAULT;
+			if (get_user(xid, (int *) arg))
+				break;
+			error = 0;
+			inode->i_xid = (xid & 0xFFFF);
+			inode->i_ctime = CURRENT_TIME;
+			mark_inode_dirty(inode);
+			break;	
+		}
+#endif
 		case FIOC_GETXFLG:
 		case FIOC_SETXFLG:
 			error = -ENOTTY;
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/jfs/jfs_imap.c linux-2.4.25-rc2-vs1.26-q0.13/fs/jfs/jfs_imap.c
--- linux-2.4.25-rc2-vs1.26/fs/jfs/jfs_imap.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/jfs/jfs_imap.c	2004-02-13 00:53:54.000000000 +0100
@@ -3101,14 +3101,21 @@ static void duplicateIXtree(struct super
 static int copy_from_dinode(struct dinode * dip, struct inode *ip)
 {
 	struct jfs_inode_info *jfs_ip = JFS_IP(ip);
+	uid_t uid;
+	gid_t gid;
 
 	jfs_ip->fileset = le32_to_cpu(dip->di_fileset);
 	jfs_ip->mode2 = le32_to_cpu(dip->di_mode);
 
 	ip->i_mode = le32_to_cpu(dip->di_mode) & 0xffff;
 	ip->i_nlink = le32_to_cpu(dip->di_nlink);
-	ip->i_uid = le32_to_cpu(dip->di_uid);
-	ip->i_gid = le32_to_cpu(dip->di_gid);
+
+	uid = le32_to_cpu(dip->di_uid);
+	gid = le32_to_cpu(dip->di_gid);
+	ip->i_uid = INOXID_UID(uid, gid);
+	ip->i_gid = INOXID_GID(uid, gid);
+	ip->i_xid = INOXID_XID(uid, gid, 0);
+	
 	ip->i_size = le64_to_cpu(dip->di_size);
 	ip->i_atime = le32_to_cpu(dip->di_atime.tv_sec);
 	ip->i_mtime = le32_to_cpu(dip->di_mtime.tv_sec);
@@ -3154,6 +3161,8 @@ static int copy_from_dinode(struct dinod
 static void copy_to_dinode(struct dinode * dip, struct inode *ip)
 {
 	struct jfs_inode_info *jfs_ip = JFS_IP(ip);
+	uid_t uid;
+	gid_t gid;
 
 	dip->di_fileset = cpu_to_le32(jfs_ip->fileset);
 	dip->di_inostamp = cpu_to_le32(JFS_SBI(ip->i_sb)->inostamp);
@@ -3162,8 +3171,11 @@ static void copy_to_dinode(struct dinode
 	dip->di_size = cpu_to_le64(ip->i_size);
 	dip->di_nblocks = cpu_to_le64(PBLK2LBLK(ip->i_sb, ip->i_blocks));
 	dip->di_nlink = cpu_to_le32(ip->i_nlink);
-	dip->di_uid = cpu_to_le32(ip->i_uid);
-	dip->di_gid = cpu_to_le32(ip->i_gid);
+
+	uid = XIDINO_UID(ip->i_uid, ip->i_xid);
+	gid = XIDINO_GID(ip->i_gid, ip->i_xid);
+	dip->di_uid = cpu_to_le32(uid);
+	dip->di_gid = cpu_to_le32(gid);
 	/*
 	 * mode2 is only needed for storing the higher order bits.
 	 * Trust i_mode for the lower order ones
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/namei.c linux-2.4.25-rc2-vs1.26-q0.13/fs/namei.c
--- linux-2.4.25-rc2-vs1.26/fs/namei.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/namei.c	2004-02-13 00:53:54.000000000 +0100
@@ -206,10 +206,22 @@ int vfs_permission(struct inode * inode,
 	return -EACCES;
 }
 
+static inline int xid_permission(struct inode *inode)
+{
+	if (inode->i_xid == 0)
+		return 0;
+	if (vx_check(inode->i_xid, VX_ADMIN|VX_WATCH|VX_IDENT))
+		return 0;
+	return -EACCES;
+}
+
 int permission(struct inode * inode,int mask)
 {
+	int retval = 0;
+
+	if ((retval = xid_permission(inode)))
+		return retval;
 	if (inode->i_op && inode->i_op->permission) {
-		int retval;
 		lock_kernel();
 		retval = inode->i_op->permission(inode, mask);
 		unlock_kernel();
@@ -1057,6 +1069,7 @@ do_last:
 
 	/* Negative dentry, just create the file */
 	if (!dentry->d_inode) {
+		vx_dq_cond_modify(dir->d_inode, current->vx_id);
 		error = vfs_create(dir->d_inode, dentry,
 				   mode & ~current->fs->umask);
 		up(&dir->d_inode->i_sem);
@@ -1129,7 +1142,7 @@ ok:
 		flag &= ~O_TRUNC;
 	} else {
 		error = -EROFS;
-		if (IS_RDONLY(inode) && (flag & 2))
+		if (IS_RDONLY(inode) && (flag & FMODE_WRITE))
 			goto exit;
 	}
 	/*
@@ -1171,6 +1184,9 @@ ok:
 		if (flag & FMODE_WRITE)
 			DQUOT_INIT(inode);
 
+	if ((flag & FMODE_WRITE) || (flag & O_TRUNC))
+		vx_dq_cond_modify(inode, current->vx_id);
+
 	return 0;
 
 exit_dput:
@@ -1492,6 +1508,8 @@ int vfs_unlink(struct inode *dir, struct
 			else {
 				lock_kernel();
 				error = dir->i_op->unlink(dir, dentry);
+				if (!error)
+					vx_dq_unlink(dentry->d_inode);
 				unlock_kernel();
 				if (!error)
 					d_delete(dentry);
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/namespace.c linux-2.4.25-rc2-vs1.26-q0.13/fs/namespace.c
--- linux-2.4.25-rc2-vs1.26/fs/namespace.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/namespace.c	2004-02-13 00:53:54.000000000 +0100
@@ -25,6 +25,7 @@ struct vfsmount *do_kern_mount(const cha
 int do_remount_sb(struct super_block *sb, int flags, void * data);
 void kill_super(struct super_block *sb);
 extern int __init init_rootfs(void);
+extern int __init init_dqhash_hash(void);
 
 static struct list_head *mount_hashtable;
 static int hash_mask, hash_bits;
@@ -334,10 +335,12 @@ static int do_umount(struct vfsmount *mn
 	spin_lock(&dcache_lock);
 
 	if (atomic_read(&sb->s_active) == 1) {
+		struct list_head *head;
 		/* last instance - try to be smart */
 		spin_unlock(&dcache_lock);
 		lock_kernel();
-		DQUOT_OFF(sb);
+		list_for_each(head, &sb->s_dqhs)
+			DQUOT_OFF(list_entry(head, struct dqhash, dqh_sblist));
 		acct_auto_close(sb->s_dev);
 		unlock_kernel();
 		spin_lock(&dcache_lock);
@@ -1068,6 +1071,7 @@ void __init mnt_init(unsigned long mempa
 		d++;
 		i--;
 	} while (i);
+	init_dqhash_hash();
 	init_rootfs();
 	init_mount_tree();
 }
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/open.c linux-2.4.25-rc2-vs1.26-q0.13/fs/open.c
--- linux-2.4.25-rc2-vs1.26/fs/open.c	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/open.c	2004-02-13 00:53:54.000000000 +0100
@@ -37,6 +37,79 @@ int vfs_statfs(struct super_block *sb, s
 }
 
 
+static inline void ctx_modify_statfs(struct super_block *sb, struct statfs *buf)
+{
+	struct dqhash *dqh;
+	struct dqh_dlimit *dl;
+	__u64 blimit, bfree, bavail;
+	__u32 ifree;
+
+	dqh = get_dqhash(sb, current->vx_id);
+	if (!dqhash_valid(dqh))
+		return;
+
+	dprintk("··· statfs %ld/%ld %ld/%ld/%ld (dqh=%p)\n",
+		buf->f_ffree, buf->f_files,
+		buf->f_bavail, buf->f_bfree, buf->f_blocks,
+		dqh);
+
+	dl = &dqh->dqh_dlimit;
+	down_read(&dl->dl_sem);
+
+	dprintk("··· dlimit %u/%u %Lu/%Lu\n",
+		dl->dl_inodes, dl->dl_ilimit,
+		dl->dl_bytes, dl->dl_blimit);
+
+	if (dl->dl_ilimit == NOILIMIT)
+		goto no_ilim;
+
+	/* reduce max inodes available to limit */
+	if (buf->f_files > dl->dl_ilimit)
+		buf->f_files = dl->dl_ilimit;
+
+	ifree = dl->dl_ilimit - dl->dl_inodes;
+	/* reduce free inodes to min */
+	if (ifree < buf->f_ffree)
+		buf->f_ffree = ifree;
+
+no_ilim:
+	if (dl->dl_blimit == NOBLIMIT)
+		goto no_blim;
+
+	blimit = dl->dl_blimit >> dl->dl_l2bsize;
+
+	if (dl->dl_blimit < dl->dl_bytes)
+		bfree = 0;
+	else
+		bfree = (dl->dl_blimit - dl->dl_bytes) >> dl->dl_l2bsize;
+
+	bavail = ((dl->dl_blimit >> 10) * dl->dl_nrlmult);
+	if (bavail < dl->dl_bytes)
+		bavail = 0;
+	else
+		bavail = (bavail - dl->dl_bytes) >> dl->dl_l2bsize;
+
+	/* reduce max space available to limit */
+	if (buf->f_blocks > blimit)
+		buf->f_blocks = blimit;
+
+	/* reduce free space to min */
+	if (bfree < buf->f_bfree)
+		buf->f_bfree = bfree;
+
+	/* reduce avail space to min */
+	if (bavail < buf->f_bavail)
+		buf->f_bavail = bavail;
+
+no_blim:
+	up_read(&dl->dl_sem);
+	dqhput(dqh);
+
+	dprintk("··· sctxfs %ld/%ld %ld/%ld/%ld\n",
+		buf->f_ffree, buf->f_files,
+		buf->f_bavail, buf->f_bfree, buf->f_blocks);
+}
+
 asmlinkage long sys_statfs(const char * path, struct statfs * buf)
 {
 	struct nameidata nd;
@@ -46,6 +119,8 @@ asmlinkage long sys_statfs(const char * 
 	if (!error) {
 		struct statfs tmp;
 		error = vfs_statfs(nd.dentry->d_inode->i_sb, &tmp);
+		if (!error)
+			ctx_modify_statfs(nd.dentry->d_inode->i_sb, &tmp);
 		if (!error && copy_to_user(buf, &tmp, sizeof(struct statfs)))
 			error = -EFAULT;
 		path_release(&nd);
@@ -64,6 +139,8 @@ asmlinkage long sys_fstatfs(unsigned int
 	if (!file)
 		goto out;
 	error = vfs_statfs(file->f_dentry->d_inode->i_sb, &tmp);
+	if (!error)
+		ctx_modify_statfs(file->f_dentry->d_inode->i_sb, &tmp);
 	if (!error && copy_to_user(buf, &tmp, sizeof(struct statfs)))
 		error = -EFAULT;
 	fput(file);
@@ -569,6 +646,10 @@ static int chown_common(struct dentry * 
 		user = inode->i_uid;
 	if (group == (gid_t) -1)
 		group = inode->i_gid;
+
+	if ((user > MAX_UID) || (group > MAX_GID))
+		goto out;
+	
 	newattrs.ia_mode = inode->i_mode;
 	newattrs.ia_uid = user;
 	newattrs.ia_gid = group;
